/*
 * This file is part of the Configuration File Library (CFL).
 * Copyright (C) 2002 Nicolas Darnis <ndarnis@free.fr>
 *
 * The CFL library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * The CFL library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the CFL library; see the file COPYING.
 * If not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 * File: section.h
 * $Revision: 1.4 $
 * $Date: 2003/05/28 15:53:51 $
 * $Author: ndarnis $
 * $Id: section.h,v 1.4 2003/05/28 15:53:51 ndarnis Exp $
 */

#ifndef _CFL_SECTION_H_
#define _CFL_SECTION_H_

#include <stdio.h>

#include <gdsl.h>

#include "cfl.h"

typedef struct _section *cfl_section_t;
typedef struct _value *cfl_value_t;

extern gdsl_element_t
section_alloc (void *arg);

extern void
section_free (gdsl_element_t e);

extern int
section_compare (gdsl_element_t e, void *key);

extern void
section_write (gdsl_element_t e, FILE *file, void *user_data);

extern void
section_write_xml (gdsl_element_t e, FILE *file, void *user_data);

extern int
section_add_value (cfl_section_t s, const char *value_name, cfl_value_type_t value_type, void *value);

extern int
section_remove_value (cfl_section_t s, const char *value_name);

extern int
section_set_value (cfl_section_t s, const char *value_name, cfl_value_type_t value_type, void *value);

extern void *
section_get_value (cfl_section_t s, const char *value_name, cfl_value_type_t *type);

extern void *
section_get_value_by_pos (cfl_section_t s, ulong value_pos, char **value_name, cfl_value_type_t *type);

extern ulong
section_get_values_number (cfl_section_t s);

extern char *
section_get_name (cfl_section_t s);

#endif /* _CFL_SECTION_H_ */
